unit MabObj;

interface

uses
   Classes, StdCtrls, DsgnIntf, DB;

type
   TMabEdit = class(TPersistent)
   private
      FCharCase: TEditCharCase;
      FMaxLength: Integer;
      FPrompt: string;
      FText: string;
   public
      constructor Create;
      procedure Assign(Source: TPersistent); override;
   published
      property CharCase: TEditCharCase
         read FCharCase
         write FCharCase
         default ecNormal;
      property MaxLength: Integer
         read FMaxLength
         write FMaxLength
         default 0;
      property Prompt: string
         read FPrompt
         write FPrompt;
      property Text: string
         read FText
         write FText;
   end;
   TMabPasswordEdit = class(TMabEdit)
   private
      FPasswordChar: Char;
   public
      constructor Create;
      procedure Assign(Source: TPersistent); override;
   published
      property PasswordChar: Char
         read FPasswordChar
         write FPasswordChar
         default #0;
   end;

implementation

constructor TMabEdit.Create;
begin
   inherited Create;

   FPrompt := '';
   FText := '';
end;

procedure TMabEdit.Assign(Source: TPersistent);
begin
   inherited Assign(Source);

   if Source is TMabEdit then
      with TMabEdit(Source) do
      begin
         Self.CharCase := CharCase;
         Self.MaxLength := MaxLength;
         Self.Prompt := Prompt;
         Self.Text := Text;
      end;
end;

constructor TMabPasswordEdit.Create;
begin
   inherited Create;

   FPasswordChar := #0;
end;

procedure TMabPasswordEdit.Assign(Source: TPersistent);
begin
   inherited Assign(Source);

   if Source is TMabPasswordEdit then
      with TMabPasswordEdit(Source) do
         Self.PasswordChar := PasswordChar;
end;

end.
 